Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/stpctl_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/stpctl_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/stpctl_tam.F90	(revision 2587)
@@ -161,6 +161,5 @@
          IF(lwp) WRITE(numout,*) ' ==>> time-step= ',kt,' abs(U) max: ', zumax
       ENDIF
-!      IF( zumax > 100.) THEN
-      IF( zumax > 500.) THEN
+      IF( zumax > 50.) THEN
          IF( lk_mpp ) THEN
             CALL mpp_maxloc(ABS(un_tl),umask,zumax,ii,ij,ik)
@@ -173,5 +172,5 @@
          IF(lwp) THEN
             WRITE(numout,cform_err)
-            WRITE(numout,*) ' stpctl_tan: the zonal velocity is larger than 20 m/s'
+            WRITE(numout,*) ' stpctl_tan: the zonal velocity is larger than 50 m/s'
             WRITE(numout,*) ' ========= '
             WRITE(numout,9400) kt, zumax, ii, ij, ik
@@ -197,6 +196,5 @@
          IF(lwp) WRITE(numout,*) ' ==>> time-step= ',kt,' abs(V) max: ', zvmax
       ENDIF
-!      IF( zvmax > 100.) THEN
-      IF( zvmax > 500.) THEN
+      IF( zvmax > 50.) THEN
          IF( lk_mpp ) THEN
             CALL mpp_maxloc(ABS(vn_tl),vmask,zvmax,ii,ij,ik)
@@ -209,5 +207,5 @@
          IF(lwp) THEN
             WRITE(numout,cform_err)
-            WRITE(numout,*) ' stpctl_tan: the meridional  velocity is larger than 10 m/s'
+            WRITE(numout,*) ' stpctl_tan: the meridional  velocity is larger than 50 m/s'
             WRITE(numout,*) ' ========= '
             WRITE(numout,9410) kt, zvmax, ii, ij, ik
@@ -232,6 +230,5 @@
          IF(lwp) WRITE(numout,*) ' ==>> time-step= ',kt,' abs(T) max: ', zTmax
       ENDIF
-!      IF( ztmax > 300.) THEN
-      IF( ztmax > 600.) THEN
+      IF( ztmax > 80.) THEN
          IF( lk_mpp ) THEN
             CALL mpp_maxloc(ABS(tn_tl),tmask,ztmax,ii,ij,ik)
@@ -244,5 +241,5 @@
          IF(lwp) THEN
             WRITE(numout,cform_err)
-            WRITE(numout,*) ' stpctl_tan: the temperature is larger than 30 K'
+            WRITE(numout,*) ' stpctl_tan: the temperature is larger than 80 K'
             WRITE(numout,*) ' ========= '
             WRITE(numout,9420) kt, ztmax, ii, ij, ik
@@ -268,6 +265,5 @@
          IF(lwp) WRITE(numout,*) ' ==>> time-step= ',kt,' abs(S) max: ', zsmax
       ENDIF
-!      IF( zsmax > 200.) THEN
-      IF( zsmax > 600.) THEN
+      IF( zsmax > 100.) THEN
          IF( lk_mpp ) THEN
             CALL mpp_maxloc(ABS(sn_tl),tmask,zsmax,ii,ij,ik)
@@ -280,5 +276,5 @@
          IF(lwp) THEN
             WRITE(numout,cform_err)
-            WRITE(numout,*) ' stpctl_tan: the Salinity is larger than 20 o/oo'
+            WRITE(numout,*) ' stpctl_tan: the Salinity is larger than 100 o/oo'
             WRITE(numout,*) ' ========== '
             WRITE(numout,9430) kt, zsmax, ii, ij, ik
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tamctl.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tamctl.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tamctl.F90	(revision 2587)
@@ -33,13 +33,10 @@
 
    LOGICAL :: &
-      & ln_tst,         & ! Master switch for operator tests
-      & ln_tst_obsadj,  & ! Switch for observation operator adjoint test
-      & ln_tst_bkgadj,  & ! Switch for bkg error covariance operator adjoint test
       & ln_tst_nemotam, & ! Switch for NEMOTAM adjoint tests
-      & ln_tst_grad,    & ! Switch for gradient test
       & ln_tst_cpd_tam, & ! Switch for NEMOTAM adjoint tests (components only)
       & ln_tst_stp_tam, & ! Switch for STEP_TAM adjoint tests
       & ln_tst_tan_cpd, & ! Switch for NEMOTAM tangent components accuracy tests 
-      & ln_tst_tan        ! Switch for NEMOTAM tangent accuracy tests
+      & ln_tst_tan,     & ! Switch for NEMOTAM tangent accuracy tests
+      & ln_tst_stop       ! Stop after tests or not
 
 
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tamtst.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tamtst.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tamtst.F90	(revision 2587)
@@ -54,4 +54,6 @@
 #endif
 
+   USE step_tam_cpd        ! Temporary
+
    IMPLICIT NONE
 
@@ -60,5 +62,5 @@
 
    PUBLIC &
-      & tstopt, &          !: Scalar product test of the adjoint routines
+      & tsttam, &          !: Scalar product test of the adjoint routines
       & numadt             !: File unit number for adjoint test output
 
@@ -69,11 +71,11 @@
 CONTAINS
 
-   SUBROUTINE tstopt
+   SUBROUTINE tsttam
       !!-----------------------------------------------------------------------
       !!
-      !!                  ***  ROUTINE tstopt  ***
+      !!                  ***  ROUTINE tsttam  ***
       !!
-      !! ** Purpose : Apply various tests (linearization, adjoint, gradient)
-      !!              on the NEMOVAR code.
+      !! ** Purpose : Apply various tests (linearization, adjoint)
+      !!              on the NEMOTAM code.
       !!
       !! ** Method  : 
@@ -85,5 +87,5 @@
       !!        ! 07-11 (A. Weaver) Add adjoint tests
       !!        ! 09-03 (I. Mirouze) Filter call depends on type
-      !!        ! 09-08 (F. Vigilant) Add tangent tests
+      !!        ! 09-08 (F. Vigilant) Split TAM and Var and add tangent tests
       !!-----------------------------------------------------------------------
       !! * Modules used
@@ -133,30 +135,12 @@
       CALL par_esp
 
-      ! ---------------------------------------------------------------
-      ! 1) Test the adjoint of the components of B
-      ! ---------------------------------------------------------------
-
-      ! Moved to NEMOVAR
-
-      ! -----------------------------------------------------
-      ! 2) Test the adjoint of H
-      ! -----------------------------------------------------
-
-      ! Moved to NEMOVAR
-
 #if defined key_tam
-      ! -----------------------------------------------------
-      ! 3) Test the adjoint of the simplification operator
-      ! -----------------------------------------------------
-
-      ! Not yet implemented
-
-      ! -----------------------------------------------------
-      ! 4) Test the adjoint of the components of M (NEMOTAM)
-      ! -----------------------------------------------------
 
       IF ( ln_tst_nemotam ) THEN
 
          IF ( ln_tst_cpd_tam ) THEN
+            ! -----------------------------------------------------
+            ! 1) Test the adjoint of the components of M (NEMOTAM)
+            ! -----------------------------------------------------
             ! *** initialize the reference trajectory
             ! ------------
@@ -206,6 +190,5 @@
             IF (lwp) WRITE(numadt,*)
 
-            IF( lk_dynspg_rl ) &
-                & CALL dyn_spg_adj_tst( numadt )    ! Surface pressure gradient
+            CALL dyn_spg_adj_tst( numadt )    ! Surface pressure gradient
 
             IF (lwp) WRITE(numadt,*)
@@ -292,6 +275,7 @@
          ENDIF
 
-         ! *** Time-loop operator
-         ! ----------------------
+         ! -----------------------------------------------------
+         ! 2) Test the adjoint of of M (NEMOTAM)
+         ! -----------------------------------------------------
          IF ( ln_tst_stp_tam ) THEN
 
@@ -303,6 +287,7 @@
 
          ENDIF
-
-         ! *** Tangent accuracy
+#if defined key_tst_tlm
+         ! -----------------------------------------------------
+         ! 3)  Test the Tangent accuracy
          ! ----------------------
          IF ( ln_tst_tan ) THEN     
@@ -310,46 +295,26 @@
             IF (ln_tst_tan_cpd) THEN
 
-               CALL flush(numout)
-
                CALL dyn_hpg_tlm_tst( numadt )
 
-               CALL flush(numout)
-
-               IF( lk_dynspg_rl ) &
-                  & CALL dyn_spg_tlm_tst( numadt )
-
-               CALL flush(numout)
+               CALL dyn_spg_tlm_tst( numadt )
+
+               CALL sol_sor_tlm_tst( numadt )
 
                CALL zps_hde_tlm_tst( numadt )
 
-               CALL flush(numout)
-
                CALL tra_sbc_tlm_tst( numadt )
 
-               CALL flush(numout)
-
                CALL dyn_adv_tlm_tst( numadt )
 
-               CALL flush(numout)
-
                CALL eos_tlm_tst( numadt )
 
-               CALL flush(numout)
-
                CALL bn2_tlm_tst( numadt )
 
-               CALL flush(numout)
-
                CALL tra_zdf_tlm_tst( numadt )
 
-               CALL flush(numout)
-
                CALL tra_adv_tlm_tst( numadt )       
 
-               CALL flush(numout)
-            
                CALL tra_ldf_tlm_tst( numadt ) 
        
-               CALL flush(numout)
             ELSE
 
@@ -363,5 +328,5 @@
 
          ENDIF
-
+#endif
       ENDIF
 #endif
@@ -372,10 +337,10 @@
       IF (lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) ' tstopt: Finished testing operators'
+         WRITE(numout,*) ' tsttam: Finished testing operators'
          WRITE(numout,*) ' ------'
          WRITE(numout,*)
       ENDIF
       CALL flush(numout)
-   END SUBROUTINE tstopt
+   END SUBROUTINE tsttam
 
 END MODULE tamtst
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tanhlt.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tanhlt.F90	(revision 2587)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/tanhlt.F90	(revision 2587)
@@ -0,0 +1,330 @@
+MODULE tanhlt
+#if defined key_tam
+   !!==============================================================================
+   !!                       ***  MODULE tan_htl   ***
+   !! Ocean system   : TAN ocean dynamics (including on-line tracers and sea-ice)
+   !!==============================================================================
+
+   !!----------------------------------------------------------------------
+   !!   tan_hlt            : solve ocean dynamics, tracer and/or sea-ice
+   !!   tan_htl_init       : initialization of the opa model 
+   !!   tan_hlt_closefile  : close remaining files
+   !!----------------------------------------------------------------------
+   !! History :
+   !!                  ()  Original code from opa
+   !!        !  10-07  (F. Vigilant) Modification for tangent linear hyp
+   !!----------------------------------------------------------------------
+   !! * Modules used
+   USE dom_oce         ! ocean space domain variables
+   USE lib_mpp         ! distributed memory computing
+   USE daymod          ! Date computations
+   USE in_out_manager  ! I/O manager
+   USE domcfg          ! domain configuration               (dom_cfg routine)
+   USE mppini          ! shared/distributed memory setting (mpp_init routine)
+   USE domain          ! domain initialization             (dom_init routine)
+   USE obc_par
+   USE obcini
+   USE phycst          ! physical constant                  (par_cst routine)
+   USE tamtrj          ! handling of the trajectory
+   USE trj_tam         ! handling of the trajectory
+   USE tamctl          ! Control parameters
+   USE oce_tam         ! TL and adjoint data
+   USE sbc_oce_tam     ! Surface BCs tangent and adjoint arrays
+   USE trc_oce_tam     ! Trend tangent and adjoint arrays
+   USE sol_oce_tam     ! Solver tangent and adjoint arrays
+   USE tamtst          ! Gradient testing
+   ! ocean physics
+#if defined key_tam
+   USE ldfdyn        ! lateral viscosity setting  (ldfdyn_init routine)
+   USE ldftra        ! lateral diffusivity setting (ldftra_init routine)
+#endif
+   USE zdfini
+   USE step_tam
+   USE istate_tam      !: Initial state setting          (istate_init routine)
+   USE par_tlm
+
+   USE hltinc, ONLY : &
+     & hlt_inc_bld
+
+   IMPLICIT NONE
+   PRIVATE
+
+   !! * Module variables
+   CHARACTER (len=64) ::        &
+      cform_aaa="( /, 'AAAAAAAA', / ) "     ! flag for output listing
+
+   !! * Routine accessibility
+   PUBLIC tan_hlt        ! called by hlttst.F90
+
+CONTAINS
+
+   SUBROUTINE tan_hlt
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE tan_hlt  ***
+      !!
+      !! ** Purpose :   tan_hlt  
+      !!
+      !! ** Method  : - model general initialization
+      !!              - launch the time-stepping (stp_tan routine)
+      !!
+      !! References :
+      !!----------------------------------------------------------------------
+      INTEGER ::   istp       ! time step index
+      !!----------------------------------------------------------------------
+
+#if defined key_agrif
+      CALL ctl_stop( '       Agrif not available')
+#endif
+      
+      CALL tan_hlt_init  ! Initializations
+
+      ! check that all process are still there... If some process have an error,
+      ! they will never enter in step and other processes will wait until the end of the cpu time!
+      IF( lk_mpp )   CALL mpp_max( nstop )
+
+      istp = nit000
+!      IF( lk_c1d ) THEN                 ! 1D configuration (no AGRIF zoom)
+!         CALL ctl_stop( '       lk_c1d not available')
+!      ELSE
+
+         istp = nit000 - 1     
+         CALL  trj_rea( istp, 1 )           
+         CALL hlt_inc_bld( nstg )      ! increment builder
+         istp = nit000
+
+         CALL istate_init_tan
+         IF( ln_trjwri_tan ) CALL tl_trj_wri( istp )
+
+         DO WHILE ( istp <= nitend .AND. nstop == 0 )
+#if defined key_agrif
+            CALL ctl_stop( '       Agrif not available')
+#else
+            CALL stp_tan( istp )
+#endif
+            istp = istp + 1
+            IF( ln_trjwri_tan ) CALL tl_trj_wri( istp )
+            IF( lk_mpp )   CALL mpp_max( nstop )
+         END DO
+
+!      ENDIF
+
+      !                                     ! ========= !
+      !                                     !  Job end  !
+      !                                     ! ========= !
+
+      IF(lwp) WRITE(numout,cform_aaa)       ! Flag AAAAAAA
+
+      IF( nstop /= 0 .AND. lwp ) THEN                 ! error print
+         WRITE(numout,cform_err)
+         WRITE(numout,*) nstop, ' error have been found' 
+      ENDIF
+
+      CALL tan_hlt_final
+
+      IF( lk_mpp )   CALL mppstop                          ! Close all files (mpp)
+      !
+   END SUBROUTINE tan_hlt
+
+   SUBROUTINE tan_hlt_init
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE tan_hlt_init  ***
+      !!
+      !! ** Purpose :   initialization of the tan model
+      !!
+      !!----------------------------------------------------------------------
+#if defined key_coupled
+      INTEGER ::   itro, istp0        ! ???
+#endif
+#if defined key_oasis3 || defined key_oasis4
+      INTEGER :: localComm
+#endif
+      !! * Local declarations
+      CHARACTER (len=128) :: file_out = 'nemohlt.output'
+!      CHARACTER (len=*), PARAMETER   ::  namelistname = 'namelist.hlt' 
+      NAMELIST/namctl/ ln_ctl, nprint, nictls, nictle,   &
+         &             isplt , jsplt , njctls, njctle, nbench, nbit_cmp
+      NAMELIST/namtst/ ln_tst_nemotam, ln_tst_cpd_tam, ln_tst_stp_tam, &
+         &             ln_tst_tan_cpd, ln_tst_tan, ln_tst_stop
+      !!----------------------------------------------------------------------
+
+      ! Initializations
+      ! ===============
+
+      ! Namelist namctl : Control prints & Benchmark
+      REWIND( numnam )
+      READ  ( numnam, namctl )
+
+      ! open additionnal listing
+      IF( ln_ctl )   THEN
+         IF( narea-1 > 0 )   THEN
+            WRITE(file_out,FMT="('nemohlt.output_',I4.4)") narea-1
+            CALL ctlopn( numout, file_out, 'UNKNOWN', 'FORMATTED',   &
+               &         'SEQUENTIAL', 1, numout, .FALSE., 1 )
+            lwp = .TRUE.
+            !
+            WRITE(numout,*)
+            WRITE(numout,*) '                 L O D Y C - I P S L'
+            WRITE(numout,*) '                     O P A model'
+            WRITE(numout,*) '            Ocean General Circulation Model'
+            WRITE(numout,*) '               version OPA 9.0  (2005) '
+            WRITE(numout,*) '                   MPI Ocean output '
+            WRITE(numout,*)
+            WRITE(numout,*)
+         ENDIF
+      ENDIF
+
+      ! Parameter control and print
+      ! ---------------------------
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '              LINEAR-TANGENT HYPOTHESIS TEST-RUN '
+         WRITE(numout,*) '              ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
+         WRITE(numout,*) '       Namelist namhlt'
+         WRITE(numout,*) '             run stage                        nstg       = ', nstg
+         IF( nstg == 1 ) THEN
+            WRITE(numout,*) '             temperature increment switch     ln_hltt    = ', ln_hltt
+            WRITE(numout,*) '             salinity increment switch        ln_hlts    = ', ln_hlts
+            WRITE(numout,*) '             velocity incr. switch            ln_hltuv   = ', ln_hltuv
+            WRITE(numout,*) '             sea surface height incr. switch  ln_hltssh  = ', ln_hltssh
+         ENDIF
+         WRITE(numout,*)
+         WRITE(numout,*)
+      ENDIF
+
+!      CALL ctlopn( numnam, namelistname, 'OLD', 'FORMATTED', 'SEQUENTIAL',   &
+!         &           1, numout, .FALSE., 1 )
+
+      ! Namelist namctl : Control prints & Benchmark
+      REWIND( numnam )
+      READ  ( numnam, namctl )
+
+      ! Nodes selection
+      nproc = mynode()
+      narea = nproc + 1    ! mynode return the rank of proc (0 --> jpnij -1 )
+      lwp   = narea == 1
+      ln_rstart = .FALSE.
+
+      ! open additionnal listing
+      IF( narea-1 > 0 )   THEN
+         WRITE(file_out,FMT="('nemohlt.output_',I4.4)") narea-1
+         IF( numout /= 0 .AND. numout /= 6 ) THEN 
+            CALL ctlopn( numout, file_out, 'UNKNOWN', 'FORMATTED',   &
+               &         'SEQUENTIAL', 1, numout, .FALSE., 1 )
+         ENDIF
+         lwp = .TRUE.
+         !
+      ENDIF      
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'nemotam_init: Control prints & Benchmark'
+         WRITE(numout,*) '~~~~~~~~~~~~ '
+         WRITE(numout,*) '          Namelist namctl'
+         WRITE(numout,*) '             run control (for debugging)     ln_ctl    = ', ln_ctl
+         WRITE(numout,*) '             level of print                  nprint    = ', nprint
+         WRITE(numout,*) '             bit comparison mode (0/1)       nbit_cmp  = ', nbit_cmp
+      ENDIF
+
+      ln_tst_nemotam = .FALSE.
+      ln_tst_cpd_tam = .FALSE.
+      ln_tst_stp_tam = .FALSE.
+      ln_tst_tan_cpd = .FALSE.
+      ln_tst_tan     = .FALSE.
+      ln_tst_stop    = .FALSE.
+
+      REWIND( numnam )
+      READ  ( numnam, namtst )
+
+      IF(lwp) THEN
+         WRITE(numout,*) ' namtst'
+         WRITE(numout,*) ' '
+         WRITE(numout,*) ' switch for M adjoint tests   ln_tst_nemotam = ',ln_tst_nemotam
+         WRITE(numout,*) ' stop after tests                ln_tst_stop = ',ln_tst_stop
+         WRITE(numout,*) ' '
+      ENDIF
+
+      IF( jpni*jpnj == jpnij ) THEN
+         CALL mpp_init                      ! standard cutting out
+      ELSE
+         CALL mpp_init2                     ! eliminate land processors
+      ENDIF
+      
+      CALL phy_cst                          ! Physical constants
+
+      CALL dom_cfg                          ! Domain configuration
+      
+      CALL dom_init                         ! Domain
+      
+      IF( lk_obc    )   CALL obc_init       ! Open boundaries 
+
+      !                                     ! Ocean physics
+
+#if defined key_tam
+      CALL ldf_dyn_init                         ! Lateral ocean momentum physics
+
+      CALL ldf_tra_init                         ! Lateral ocean tracer physics
+#endif
+
+      CALL zdf_init                             ! Vertical ocean physics
+
+      CALL     oce_tam_init( 0 )            ! OCE TAM field
+      CALL sol_oce_tam_init( 0 )            ! Initialize elliptic solver
+      CALL trc_oce_tam_init( 0 )            ! TRC TAM fields
+#if defined key_tam
+      CALL sbc_oce_tam_init( 0 )            ! SBC TAM fields
+#endif
+      CALL tam_trj_ini
+      CALL tl_trj_ini
+
+      CALL day_init
+      CALL day( nit000 )
+
+   END SUBROUTINE tan_hlt_init
+
+   SUBROUTINE tan_hlt_final
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE opa_closefile  ***
+      !!
+      !! ** Purpose :   Close the files
+      !!
+      !! ** Method  :
+      !!
+      !! History :
+      !!   9.0  !  05-01  (O. Le Galloudec)  Original code
+      !!----------------------------------------------------------------------
+      !! * Modules used
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,cform_aaa)       ! Flag AAAAAAA
+
+      IF( nstop /= 0 ) THEN                 ! error print
+         IF(lwp) WRITE(numout,cform_err)
+         IF(lwp) WRITE(numout,*) nstop, ' error have been found' 
+      ENDIF
+
+      IF ( lk_mpp ) CALL mppsync
+
+      ! Deallocate variables
+      ! --------------------
+      CALL oce_tam_deallocate ( 0 )
+      CALL sol_oce_tam_deallocate ( 0 )
+#if defined key_tam
+      CALL sbc_oce_tam_deallocate ( 0 )
+      CALL trc_oce_tam_deallocate ( 0 )
+#endif
+      CALL trj_deallocate
+      ! Unit close
+      ! ----------
+
+      CLOSE( numnam )       ! namelist
+      CLOSE( numout )       ! standard model output file
+!      CLOSE( numtan_sc )    ! tangent test diagnostic output
+!      CLOSE( numtan )       ! tangent diagnostic output
+
+      IF ( lk_mpp ) CALL mppstop
+
+   END SUBROUTINE tan_hlt_final
+
+   !!======================================================================
+#endif
+END MODULE tanhlt
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/trc_oce_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/trc_oce_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/trc_oce_tam.F90	(revision 2587)
@@ -37,4 +37,5 @@
    PUBLIC &
       & trc_oce_tam_init, & !: Initialize the trend TAM fields
+      & trc_oce_tam_deallocate, & !: Deallocate the trend TAM fields
       & etot3_tl, &
       & etot3_ad
@@ -103,5 +104,47 @@
 
    END SUBROUTINE trc_oce_tam_init
+   SUBROUTINE trc_oce_tam_deallocate( kindic )
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE trc_oce_tam_deallocate  ***
+      !!
+      !! ** Purpose : Deallocate the tangent linear and
+      !!              adjoint arrays
+      !!
+      !! ** Method  : kindic = 0  deallocate both tl and ad variables
+      !!              kindic = 1  deallocate only tl variables
+      !!              kindic = 2  deallocate only ad variables
+      !!
+      !! ** Action  :
+      !!
+      !! References :
+      !!
+      !! History :
+      !!        ! 2010-06 (A. Vidard) Initial version
+      !!-----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT(IN) :: &
+         & kindic        ! indicate which variables to deallocate
 
+      !! * Local declarations
+      ! Deallocate tangent linear variable arrays
+      ! ---------------------------------------
+
+      IF ( kindic == 0 .OR. kindic == 1 ) THEN
+
+         IF ( ALLOCATED(etot3_tl) ) DEALLOCATE( etot3_tl )
+
+      END IF
+
+      IF ( kindic == 0 .OR. kindic == 2 ) THEN
+            
+         ! Deallocate adjoint variable arrays
+         ! --------------------------------
+
+         IF ( ALLOCATED(etot3_ad) ) DEALLOCATE( etot3_ad )
+
+      END IF
+
+   END SUBROUTINE trc_oce_tam_deallocate
 #endif
 END MODULE trc_oce_tam
